/*
 * This module contains our Application_Initialize() function,
 * based on the disassembly of the binary object version in the
 * Leonardo semi-src.
 */

#include "../include/config.h"

Application_Initialize()
{
	Init_Target();
	/*
	 * The original version calls Init_Drivers() at this point,
	 * but that function is nothing more than a short sequence
	 * of calls to other functions, so I've inlined it.
	 */
	ABB_Sem_Create();
	ffs_main_init();
	rvf_init();
	rvm_init();
	create_tasks();
#if 0
	SIM_Initialize();
#endif
	/* end of Init_Drivers() */
#if CONFIG_GSM
	Cust_Init_Layer1();
#endif
	Init_Serial_Flows();
#if CONFIG_GSM
	StartFrame();
#endif
	Init_Unmask_IT();
}
