/*
 * This module contains the initialization code for fc-tmsh.
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <stdlib.h>
#include <unistd.h>
#include "pktmux.h"
#include "localsock.h"

extern char *socket_pathname;
extern int sock;

connect_local_socket()
{
	/* local socket binding voodoo copied from osmocon */
	struct sockaddr_un local;
	unsigned int namelen;
	int rc;

	sock = socket(AF_UNIX, SOCK_STREAM, 0);
	if (sock < 0) {
		perror("socket(AF_UNIX, SOCK_STREAM, 0)");
		exit(1);
	}

	local.sun_family = AF_UNIX;
	strncpy(local.sun_path, socket_pathname, sizeof(local.sun_path));
	local.sun_path[sizeof(local.sun_path) - 1] = '\0';

	/* we use the same magic that X11 uses in Xtranssock.c for
	 * calculating the proper length of the sockaddr */
#if defined(BSD44SOCKETS) || defined(__UNIXWARE__)
	local.sun_len = strlen(local.sun_path);
#endif
#if defined(BSD44SOCKETS) || defined(SUN_LEN)
	namelen = SUN_LEN(&local);
#else
	namelen = strlen(local.sun_path) +
		  offsetof(struct sockaddr_un, sun_path) + 1;
#endif

	rc = connect(sock, (struct sockaddr *) &local, namelen);
	if (rc != 0) {
		perror(socket_pathname);
		exit(1);
	}

	return(0);
}

send_init_command(cmdpkt, cmdlen)
	u_char *cmdpkt;
{
	u_char lenbuf[2];

	lenbuf[0] = 0;
	lenbuf[1] = cmdlen;
	write(sock, lenbuf, 2);
	write(sock, cmdpkt, cmdlen);
}

init()
{
	static u_char want_rvt_lost[9] = {CLI2RVI_WANT_RVTRACE,
					  0xFF, 0xFF, 0xFF, 0xFF,
					  0x00, 0x00, 0x00, 0x00};
	static u_char want_rvt_etm[9]  = {CLI2RVI_WANT_RVTRACE,
					  0xFF, 0xFF, 0xFF, 0xFF,
					  0x00, 0x1E, 0x00, 0x04};
	static u_char want_etm_mux[2] = {CLI2RVI_WANT_MUXPROTO, RVT_TM_HEADER};

	if (!sock)
		connect_local_socket();
	localsock_prep_for_length_rx();
	send_init_command(want_rvt_lost, 9);
	send_init_command(want_rvt_etm, 9);
	send_init_command(want_etm_mux, 2);
}
